/*------------------------------------------------------------------------------------------------------------------------------------------------------------------------>
<!-------------------- CUBASIS USER GUIDE SEARCH ------------------------------------------------------------------------------------------------------------->
<!-------------------- v.3.5_1.7  - last modified: 26.09.2013 ----------------------------------------------------------------------------------------------------->
<!-------------------- © 2013 STEINBERG MEDIA TECHNOLOGY GmbH ----------------------------------------------------------------------------------------->
<!------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------
** returns the levenshteinDistance of two numbers
**----------------------------------------------------------------------*/
function mrlevenshtein(userInput,keyword) {
	userInput = userInput.toLowerCase();
	keyword = keyword.toLowerCase();

	//Hashmap declaration
	var d = new Array(40);
	for (var i = 0; i < d.length; i++) {
		d[i] = new Array(d.length);
	}

	//Initialisation of Top Row
	for (var i=0;i<d.length;i++) {
		d[i][0] = i;
	}

	//Initialisation of Left Row
	for (var j = 0; j < d[0].length; j++) {
		d[0][j] = j;
	}

	//Fill Levenshtein Array
	for (var k = 1; k <= keyword.length; k++) {
		for (var m = 1; m <= userInput.length; m++) {
			if (userInput[m - 1] == keyword[k - 1]) {
				d[k][m] = d[k - 1][m - 1];
			}
			else {
				d[k][m] = Math.min(d[k-1][m]+1, d[k][m-1]+1, d[k-1][m-1]+1);
			}
		}	
	}		
	
	return d[keyword.length][userInput.length];
}
